<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>32. Python Language Services &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="The Python Standard Library" href="index.html" />
    <link rel="next" title="32.1. parser — Access Python parse trees" href="parser.html" />
    <link rel="prev" title="31.5. importlib – The implementation of import" href="importlib.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="parser.html" title="32.1. parser — Access Python parse trees"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="importlib.html" title="31.5. importlib – The implementation of import"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="python-language-services">
<span id="language"></span><h1>32. Python Language Services<a class="headerlink" href="#python-language-services" title="Permalink to this headline">¶</a></h1>
<p>Python provides a number of modules to assist in working with the Python
language.  These modules support tokenizing, parsing, syntax analysis, bytecode
disassembly, and various other facilities.</p>
<p>These modules include:</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="parser.html">32.1. <code class="docutils literal"><span class="pre">parser</span></code> &#8212; Access Python parse trees</a><ul>
<li class="toctree-l2"><a class="reference internal" href="parser.html#creating-st-objects">32.1.1. Creating ST Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="parser.html#converting-st-objects">32.1.2. Converting ST Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="parser.html#queries-on-st-objects">32.1.3. Queries on ST Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="parser.html#exceptions-and-error-handling">32.1.4. Exceptions and Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="parser.html#st-objects">32.1.5. ST Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="parser.html#example-emulation-of-compile">32.1.6. Example: Emulation of <code class="docutils literal"><span class="pre">compile()</span></code></a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="ast.html">32.2. <code class="docutils literal"><span class="pre">ast</span></code> &#8212; Abstract Syntax Trees</a><ul>
<li class="toctree-l2"><a class="reference internal" href="ast.html#node-classes">32.2.1. Node classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="ast.html#abstract-grammar">32.2.2. Abstract Grammar</a></li>
<li class="toctree-l2"><a class="reference internal" href="ast.html#ast-helpers">32.2.3. <code class="docutils literal"><span class="pre">ast</span></code> Helpers</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="symtable.html">32.3. <code class="docutils literal"><span class="pre">symtable</span></code> &#8212; Access to the compiler&#8217;s symbol tables</a><ul>
<li class="toctree-l2"><a class="reference internal" href="symtable.html#generating-symbol-tables">32.3.1. Generating Symbol Tables</a></li>
<li class="toctree-l2"><a class="reference internal" href="symtable.html#examining-symbol-tables">32.3.2. Examining Symbol Tables</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="symbol.html">32.4. <code class="docutils literal"><span class="pre">symbol</span></code> &#8212; Constants used with Python parse trees</a></li>
<li class="toctree-l1"><a class="reference internal" href="token.html">32.5. <code class="docutils literal"><span class="pre">token</span></code> &#8212; Constants used with Python parse trees</a></li>
<li class="toctree-l1"><a class="reference internal" href="keyword.html">32.6. <code class="docutils literal"><span class="pre">keyword</span></code> &#8212; Testing for Python keywords</a></li>
<li class="toctree-l1"><a class="reference internal" href="tokenize.html">32.7. <code class="docutils literal"><span class="pre">tokenize</span></code> &#8212; Tokenizer for Python source</a><ul>
<li class="toctree-l2"><a class="reference internal" href="tokenize.html#tokenizing-input">32.7.1. Tokenizing Input</a></li>
<li class="toctree-l2"><a class="reference internal" href="tokenize.html#command-line-usage">32.7.2. Command-Line Usage</a></li>
<li class="toctree-l2"><a class="reference internal" href="tokenize.html#examples">32.7.3. Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="tabnanny.html">32.8. <code class="docutils literal"><span class="pre">tabnanny</span></code> &#8212; Detection of ambiguous indentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="pyclbr.html">32.9. <code class="docutils literal"><span class="pre">pyclbr</span></code> &#8212; Python class browser support</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pyclbr.html#class-objects">32.9.1. Class Objects</a></li>
<li class="toctree-l2"><a class="reference internal" href="pyclbr.html#function-objects">32.9.2. Function Objects</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="py_compile.html">32.10. <code class="docutils literal"><span class="pre">py_compile</span></code> &#8212; Compile Python source files</a></li>
<li class="toctree-l1"><a class="reference internal" href="compileall.html">32.11. <code class="docutils literal"><span class="pre">compileall</span></code> &#8212; Byte-compile Python libraries</a><ul>
<li class="toctree-l2"><a class="reference internal" href="compileall.html#command-line-use">32.11.1. Command-line use</a></li>
<li class="toctree-l2"><a class="reference internal" href="compileall.html#public-functions">32.11.2. Public functions</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="dis.html">32.12. <code class="docutils literal"><span class="pre">dis</span></code> &#8212; Disassembler for Python bytecode</a><ul>
<li class="toctree-l2"><a class="reference internal" href="dis.html#bytecode-analysis">32.12.1. Bytecode analysis</a></li>
<li class="toctree-l2"><a class="reference internal" href="dis.html#analysis-functions">32.12.2. Analysis functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="dis.html#python-bytecode-instructions">32.12.3. Python Bytecode Instructions</a></li>
<li class="toctree-l2"><a class="reference internal" href="dis.html#opcode-collections">32.12.4. Opcode collections</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pickletools.html">32.13. <code class="docutils literal"><span class="pre">pickletools</span></code> &#8212; Tools for pickle developers</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pickletools.html#command-line-usage">32.13.1. Command line usage</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pickletools.html#command-line-options">32.13.1.1. Command line options</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pickletools.html#programmatic-interface">32.13.2. Programmatic Interface</a></li>
</ul>
</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="importlib.html"
                        title="previous chapter">31.5. <code class="docutils literal"><span class="pre">importlib</span></code> &#8211; The implementation of <code class="docutils literal"><span class="pre">import</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="parser.html"
                        title="next chapter">32.1. <code class="docutils literal"><span class="pre">parser</span></code> &#8212; Access Python parse trees</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/language.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="parser.html" title="32.1. parser — Access Python parse trees"
             >next</a> |</li>
        <li class="right" >
          <a href="importlib.html" title="31.5. importlib – The implementation of import"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 16, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>